#include "defns.h"

/**
 * Structure for the Binary Search Tree Nodes.
 * Each node holds the data, the nodes' subtree height and pointers to the left and right children of the node.
 */
typedef struct _BSTreeNode {
	Type data;						// The data
	int height;						// The subtree height
	struct _BSTreeNode *leftChild;	// Pointer to the left child. All the nodes under this child have values <= than this nodes data.
	struct _BSTreeNode *rightChild;	// Pointer to the right child. All the nodes under this child have values > than this nodes data.
	struct _BSTreeNode *father;		// Pointer to the father node. If the node is the root, this is NULL.
} BSTreeNode;

/**
 * Structure for a Binary Search Tree.
 * Holds a pointer to the root node.
 */
typedef struct _BSTree {
	BSTreeNode *root;			// Pointer to the root node.
} BSTree;


BSTreeNode *createNode(Type value);
void insertNode(BSTreeNode *root, BSTreeNode *node);
void deleteSubtree(BSTreeNode *root);
BSTreeNode *findNode(BSTreeNode *root, Type value);
void printNodeInfix(BSTreeNode *root);
void printNodePrefix(BSTreeNode *root);
void printNodePostfix(BSTreeNode *root);
int subtreeHeight(BSTreeNode *root);

BSTree *createTree(void);
void deleteTree(BSTree *tree);
void insertData(BSTree *tree, Type value);
void printTree(BSTree *tree);
BSTreeNode *findData(BSTree *tree, Type value);
BOOL dataExists(BSTree *tree, Type value);



